require "fileutils"
require "forwardable"
require "pathname"
require "yaml"
require "cgi"

require "tilt"
require "fixer_upper"

if Gem::Specification.find_all_by_name("pry-byebug").any?
  require "pry-byebug"
elsif Gem::Specification.find_all_by_name("pry").any?
  require "pry"
end

# Core
require "munge/version"
require "munge/item"
require "munge/error"
require "munge/util/path"
require "munge/util/symbol_hash"
require "munge/util/boolean_regex"
require "munge/conglomerate/router"
require "munge/conglomerate/router/itemish"
require "munge/conglomerate/item_factory"
require "munge/conglomerate/item_factory/content_parser"
require "munge/conglomerate/item_factory/item_identifier"
require "munge/conglomerate/collection"
require "munge/conglomerate/reader"
require "munge/conglomerate/processor"
require "munge/conglomerate"
require "munge/vfs/dry_run"
require "munge/vfs/filesystem"
require "munge/vfs/memory"
require "munge/write_manager/all"
require "munge/write_manager/only_needed"
require "munge/function/clean"
require "munge/function/write"
require "munge/application"
require "munge/config"
require "munge/reporter"
require "munge/pre_init"
require "munge/bootloader"
require "munge/load"

# Extensions
require "munge/helper/asset_tags"
require "munge/helper/asset_paths"
require "munge/helper/capture"
require "munge/helper/data"
require "munge/helper/find"
require "munge/helper/link"
require "munge/helper/rendering"
require "munge/helper/tag"
require "munge/helper/livereload"
require "munge/helper/define_module"
require "munge/router/auto_add_extension"
require "munge/router/fingerprint"
require "munge/router/add_directory_index"
require "munge/router/remove_index_basename"

require "munge/extra/livereload"
